using System;

namespace OrbitOne.CRMUpdater.CRM
{
    public class UpdaterErrorEventArgs : EventArgs
    {
        public int ColumnIndex { get; private set; }
        public int RowIndex { get; private set; }
        public Exception Exception { get; private set; }
        public UpdaterErrorEventArgs(Exception ex, int rowindex, int colindex)
        {
            this.Exception = ex;
            this.RowIndex = rowindex;
            this.ColumnIndex = colindex;
        }
    }
    public class RowUploadCompletedEventArgs : EventArgs
    {
        public int RowIndex { get; private set; }
        public string Message { get; private set; }
        public RowUploadCompletedEventArgs(int row, string message)
        {
            this.RowIndex = row;
            this.Message = message;
        }
    }
}